#include "global.h"
#include <time.h>

#define SIMPLE_MSG(name,msg) void std##name () {cout << msg << endl;}
SIMPLE_MSG(hello_world,"Hello World!")
SIMPLE_MSG(internet_upload,"Uploading some data to the internet...")
SIMPLE_MSG(internet_download,"Downloading some data from the internet...")
SIMPLE_MSG(generate_random,"Generating some random numbers...")
SIMPLE_MSG(calculate_42,"Calculating the meaning of life...")
SIMPLE_MSG(print_random_hex,hex << "0x" << rand() << dec)
SIMPLE_MSG(print_random_dec,rand())
void stdprint_date () {
	time_t now;
	time(&now);
	cout << ctime(&now);
}

#define SIMPLE_PMSG(name,msg) void param##name  (string p) {cout << msg << endl;}
SIMPLE_PMSG(internet_upload,"Uploading \"" << p << "\" to the internet...")
SIMPLE_PMSG(internet_download,"Downloading \"" << p << "\" from the internet...")
SIMPLE_PMSG(internet_similar,"Downloading random files similar to \"" << p << "\" from the internet...")
SIMPLE_PMSG(delete_,"Deleting file \"" << p << "\"...")
SIMPLE_PMSG(create_new,"Creating new file \"" << p << "\"...")
SIMPLE_PMSG(append_rand,"Append random data to file \"" << p << "\"...")
SIMPLE_PMSG(printer,"Transfer file \"" << p << "\" to printer...")
SIMPLE_PMSG(print,"Print file \"" << p << "\" to secret debug log...")
SIMPLE_PMSG(send_ea,"Send file \"" << p << "\" to EA...")
SIMPLE_PMSG(send_ubisoft,"Send file \"" << p << "\" to Ubisoft")

#define FUNC(name) stdFunctions.push_back(std##name);stdEntries.push_back(0)
#define PFUNC(name) paramFunctions.push_back(param##name);paramEntries.push_back(0)
Petrovich::Petrovich ()
{
	FUNC(hello_world);
	FUNC(internet_upload);
	FUNC(internet_download);
	FUNC(generate_random);
	FUNC(calculate_42);
	FUNC(print_random_hex);
	FUNC(print_random_dec);
	FUNC(print_date);

	PFUNC(internet_upload);
	PFUNC(internet_download);
	PFUNC(internet_similar);
	PFUNC(delete_);
	PFUNC(create_new);
	PFUNC(append_rand);
	PFUNC(printer);
	PFUNC(print);
	PFUNC(send_ea);
	PFUNC(send_ubisoft);
	lastAction.function=-1;
}
#undef SIMPLE_MSG
#undef SIMPLE_PMSG